Disp_EN_Pulse:			
		sbi	PortD,Display_EN_Bit	;Display_EN=H
		nop
		nop
		nop
		nop
		nop
		cbi	PortD,Display_EN_Bit	;Display_EN=L
		ret
		
Init_Display:;*** Display nach Inbetriebname initialisieren
		ldi	WorkU1,240		;4x12ms
		rcall	Pause_n50us
		rcall	Pause_n50us
		rcall	Pause_n50us
		rcall	Pause_n50us		
		ldi	WorkU,PortD_DIR_W
		out	DDRD,r20		;Datenleitungen auf Ausg.
		ldi	WorkU,0b00000011	;8-Bit,Bel Aus
		out	PortD,WorkU		;Ausgabe
		rcall	Disp_EN_Pulse
		ldi	WorkU1,180		;9ms
		rcall	Pause_n50us
		rcall	Disp_EN_Pulse
		ldi	WorkU1,50		;2.5ms
		rcall	Pause_n50us
		rcall	Disp_EN_Pulse
		ldi	WorkU1,50		;2.5ms
		rcall	Pause_n50us
		ldi	WorkU,0b00000010	;4-Bit;Bel Aus
		out	PortD,WorkU		;Ausgabe
		rcall	Disp_EN_Pulse
		ldi	WorkU1,50		;2.5ms
		rcall	Pause_n50us
		ldi	DispDat,40		;4-Bit Display; mehrzeilig; 5x7 Font
		rcall	Disp_Send_Code
		ldi	DispDat,8+4		;Display Ein; kein Cursor; kein Blinken
		rcall	Disp_Send_Code
		ldi	DispDat,1		;Display lschen
		rcall	Disp_Send_Code
		ldi	DispDat,4+2		;Adr-Ptr INC; Disp-Inhalt nicht schieben
		rjmp	Disp_Send_Code
		;ret

Disp_Send_Data:	;1 Datenbyte (DispDat) an Display
		sbi	PortD,Display_RS_Bit	;Data_Output
		rjmp	Disp_S
Disp_Send_Code:	;1 SteuerByte (DispDat) an Display ausgeben
		cbi	PortD,Display_RS_Bit	;Code_Output
Disp_S:		push	TempU1
		push	TempU2
		rcall	Disp_Status	
		cbi	PortD,Display_RW_Bit	;Data_Write
		ldi	TempU1,PortD_DIR_W
		out	DDRD,TempU1		;DataDIR Port D	
		mov	TempU2,DispDat
		swap	DispDat			;H-Teil
		andi	DispDat,$0F
		in	TempU1,PortD		;PortB_DataReg
		andi	TempU1,$F0
		or	DispDat,TempU1		;Datenbits
		out	PortD,DispDat
		rcall	Disp_EN_Pulse

		andi	TempU2,$0F		;L-Teil
		or	TempU2,TempU1		;Datenbits
		out	PortD,TempU2
		rcall	Disp_EN_Pulse

		ldi	TempU1,PortD_DIR_R
		out	DDRD,TempU1		;DataDIR Port D	
		;FR TEST
		pop	TempU2
		pop	TempU1
		
		;ldi	WorkU1,20	;20
		;rcall	Pause_n50us
		;##
		ret

Disp_KPause:	;Pause fr mindest Zykluszeit bei BF-Abfr.
		push	r16
		ldi	r16,4
DS_PL0:		dec	r16
		brne	DS_PL0		;9Takte=1.125us
		pop	r16
		ret

Disp_Status:	;*** Display Status auslesen
		ldi	TempU1,PortD_DIR_R
		out	DDRD,TempU1		;DataDIR Port D
		in	TempU2,PortD
		andi	TempU2,$F0		;SteuerL. sichern
		sbi	PortD,Display_RW_Bit	;Data_Read (R/W=1)
		cbi	PortD,Display_RS_Bit	;Read_Code (R/S=0)

Disp_Wait:	sbi	PortD,Display_EN_Bit	;Display_EN=H
		nop
		nop
		in	TempU1,PinD		;Daten lesen
		bst	TempU1,3		;BF->T
		cbi	PortD,Display_EN_Bit	;Display_EN=L
		rcall	Disp_KPause
		rcall	Disp_EN_Pulse		;2. Halbbyte
		brtc	Disp_Ok
		rcall	Disp_KPause
		rjmp	Disp_Wait
Disp_Ok:	out	PortD,TempU2		;Steuerleitungen wiederherstellen
		ret

DezOut:		;WorkU1 _ Wert (0..99)
		clr	DispDat
DezOut_M00:	cpi	WorkU1,10
		brcs	DezOut_M01
		subi	WorkU1,10
		inc	DispDat
		rjmp	DezOut_M00
DezOut_M01:	adi	DispDat,$30
		rcall	Disp_Send_Data		;Zehner
		mov	DispDat,WorkU1
		adi	DispDat,$30
		rjmp	Disp_Send_Data		;Einer
		;ret

HexOut:		;X _ Wert ($0000 ... $FFFF)
		mov	TempL1,X_H
		swap	TempL1		;UPPER 4 Bits
		rcall	HexOu1
		mov	TempL1,X_L
		swap	TempL1
		rjmp	HexOu1
		;ret
HexOu1:		ldi	TempU1,2
HexOu1l:	mov	DispDat,TempL1		
		andi	DispDat,$F
		adi	DispDat,$30
		cpi	DispDat,$3a
		brcs	HexOu1a
		adi	DispDat,7
HexOu1a:	rcall	Disp_Send_Data		
		swap	TempL1		;LOWER 4 BITS
		dec	TempU1
		brne	HexOu1l
		ret
